Subject: Re: [RFC PATCH] unpack-trees: watch for out-of-range index position

From: Emily Shaffer <[email-masked]>
Date: Thu, 9 Jan 2020 14:46:41 -0800

On Thu, Jan 09, 2020 at 02:52:50AM -0500, Jeff King wrote:
> On Wed, Jan 08, 2020 at 12:35:29PM -0800, Junio C Hamano wrote:
> 
> > >> It does not sound like a BUG to me, either, but the new condition
> > >> does look correct to me, too.  We can turn it into die() later if
> > >> somebody truly cares ;-)
> > >> 
> > >> Thanks, both.  Will queue.
> > >
> > > Thanks much for the quick turnaround. If I hear more noise I'll give it
> > > a try with die() or error code instead, but for now I'll move on to the
> > > next bug on my list. :)
> > 
> > By the way, it is somewhat sad that we proceeded that far in the
> > first place---such a corrupt on-disk index would have caused an
> > early die() if we did not get rid of the trailing-hash integrity
> > check.
> 
> Perhaps. The integrity check only protects against an index that was
> modified after the fact, not one that was generated by a buggy Git. I'm
> not sure we know how the index that led to this patch got into this
> state (though it sounds like Emily has a copy and could check the hash
> on it), but other cache-tree segfault I found recently was with an index
> with an intact integrity hash.

Yeah, I can do that, although I'm not sure how. The index itself is very
small - it only contains one file and one tree extension - so I'll go
ahead and paste some poking and prodding, and if it's not what you
wanted then please let me know what else to run.

  $ g fsck --cache
  Checking object directories: 100% (256/256), done.
  Checking objects: 100% (20/20), done.
  broken link from  commit 153a9a100eae7fdba5989ce39a5dd1782075517f
                to  commit cca7ecaa5d8c398f41bfec7938cc6a526803579b
  broken link from  commit 7d6bb91e31d18eadfaf855a9fb7ad6ba81b8b6d9
                to  commit 03087a617bfe55f862cb1ef43273a2bd08e8b6d6
  missing commit 03087a617bfe55f862cb1ef43273a2bd08e8b6d6
  missing commit cca7ecaa5d8c398f41bfec7938cc6a526803579b
  dangling commit 5e2c635433bc46b13061b276e481f63b1f6642c8

  $ hexdump -C .git/index
  00000000  44 49 52 43 00 00 00 02  00 00 00 01 5d 89 5e 22  |DIRC........].^"|
  00000010  23 bf a3 c4 5d 89 5e 22  23 bf a3 c4 00 00 fe 02  |#...].^"#.......|
  00000020  02 c8 f5 83 00 00 81 a4  00 06 c1 dc 00 01 5f 53  |.............._S|
  00000030  00 00 06 b3 78 88 a4 f4  22 34 7d ad b0 c4 73 0f  |....x..."4}...s.|
  00000040  c5 bc f6 ea 1d 2d f0 3a  00 09 52 45 41 44 4d 45  |.....-.:..README|
  00000050  2e 6d 64 00 54 52 45 45  00 00 00 3a 00 31 37 20  |.md.TREE...:.17 |
  00000060  31 0a da 7f 67 25 40 7d  4e ce 9f d3 72 ce 4c e8  |1...g%@}N...r.L.|
  00000070  40 6d 5d ad e9 79 67 69  74 6c 69 6e 74 00 34 20  |@m]..ygitlint.4 |
  00000080  30 0a 93 63 25 17 69 e6  d6 92 78 97 55 4b 0f 8b  |0..c%.i...x.UK..|
  00000090  ff a0 e8 2d 6d 71 32 d1  69 fc f2 38 42 f8 5a 6e  |...-mq2.i..8B.Zn|
  000000a0  05 35 d6 94 41 c0 9f c7  ba 43                    |.5..A....C|
  000000aa

  $ find .git/objects -type f
  .git/objects/pack/pack-5e5d5e7c3cbd60a99b4c0295a2935885fbb235a1.idx
  .git/objects/pack/pack-5e5d5e7c3cbd60a99b4c0295a2935885fbb235a1.pack
  .git/objects/15/3a9a100eae7fdba5989ce39a5dd1782075517f
  .git/objects/5e/2c635433bc46b13061b276e481f63b1f6642c8

(By the way, cat-file barfs on both those loose objects, for the reason fsck
reveals.)

I hope that's helpful.

 - Emily